import Data.List
import Data.Map
import System.IO
import Data.Char(toLower,isAlpha)
import System.Environment (getArgs)
import System.Environment (getArgs)
import Control.Parallel.Strategies
import Data.Sequence
import Control.Concurrent.Async
import Control.DeepSeq 




non_digit_in_word :: String -> String
non_digit_in_word [] = []
non_digit_in_word (x:xs)
             | isAlpha x = toLower x : non_digit_in_word xs
             | otherwise = non_digit_in_word xs  

clean_words:: [String] -> [String]
clean_words xs =  fmap non_digit_in_word xs





makeBigrams :: [String] -> [(String,String)]
makeBigrams [] = []
makeBigrams xs =
  snd (Prelude.foldr (\x (a,b) -> 
              case a of 
                Nothing -> (Just x,b) 
                Just y  -> (Just x,(x,y):b)  
           ) (Nothing,[]) xs)




mkDatabase2 :: [(String,String)] -> Map String [(String, Int)]
mkDatabase2 m = 
  let p = fromListWith (\x y ->(x++y)) $ fmap (\(a,b) -> (a,[b])) m
  in fmap (\m-> toList $ fromListWith (+) $ fmap (\x -> (x,1)) m ) p 

getTopFiveResults :: Maybe [(String, Int)] -> [String]
getTopFiveResults Nothing = [] 
getTopFiveResults (Just lis) = fmap (fst) $ (Prelude.take 5 $ Data.List.sortBy (\(_,x) (_,y)-> compare x y) lis )

getUserWord :: IO String
getUserWord = do 
  putStrLn "Please enter an input"
  line <- getLine
  return $ fmap toLower line




main :: IO ()
main = do
  z <- mapM readFile $ fmap (\x-> "revi" ++  show x ) [0..9]

  let x = concat $ parMap rpar (parMap rpar (clean_words . words) . lines) z  
  let y = concat $ parMap rpar makeBigrams x

  let database = mkDatabase2 y
  getUserWordWhileNotQuit database
  where
    getUserWordWhileNotQuit database  = do
      word <- getUserWord
      let z = words word 
      case z of 
        [] -> putStrLn "Erorr - empty input"
        _ -> do 
          putStrLn "Here are the suggestion words (if found)"
          putStrLn $ show $ getTopFiveResults $ Data.Map.lookup (head z) database



